
{*******************************************************}
{                                                       }
{       Borland Delphi Visual Component Library         }
{       Borland Socket Server source code               }
{                                                       }
{       Copyright (c) 1997,99 Inprise Corporation       }
{                                                       }
{*******************************************************}

unit bugFrmService;

interface

uses
  SvcMgr, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ShellAPI, ExtCtrls, StdCtrls, ComCtrls, ScktComp, Registry,
  ActnList, bugService, bugSvcCnst;

type

  TFrmService = class(TForm)
    mnuPopUp: TPopupMenu;
    mniClose: TMenuItem;
    mniN1: TMenuItem;
    mniProperties: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure mniCloseClick(Sender: TObject);
    procedure mniPropertiesClick(Sender: TObject);
  private
    FwinIconData: TNotifyIconData;
    FbooFromService: Boolean;
    FbooNT351: Boolean;
  protected
    //svcmessages
      procedure UIInitialize(var Message: TMessage); message UI_INITIALIZE;
      procedure UIClose(var Message: TMessage); message UI_CLOSE;

        procedure WMSVCIcon(var Message: TMessage); message WM_SVCICON;
        procedure AddIcon;
  public
    procedure Initialize(pbooFromService: Boolean);

  end;

var
  FrmService: TFrmService;

implementation


{$R *.DFM}

{ TFrmAFService }



procedure TFrmService.AddIcon;
begin
  if not FBooNT351 then begin
    with FwinIconData do begin
      cbSize := SizeOf(FwinIconData);
      Wnd := Self.Handle;
      uID := $DEDB;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      hIcon := Forms.Application.Icon.Handle;
      uCallbackMessage := WM_SVCICON;
      StrCopy(szTip, PChar(Caption));
    end;
    Shell_NotifyIcon(NIM_Add, @FwinIconData);
  end;
end;

procedure TFrmService.FormDestroy(Sender: TObject);
begin
  if not FbooNT351 then
    Shell_NotifyIcon(NIM_DELETE, @FwinIconData);

end;


procedure TFrmService.Initialize(pbooFromService: Boolean);
begin
  FbooFromService := pbooFromService;
  FbooNT351 := (Win32MajorVersion <= 3) and (Win32Platform = VER_PLATFORM_WIN32_NT);
  if FBooNT351 then begin
    if not pbooFromService then
      raise Exception.Create('Can Only run as Service on NT 3.5');
    BorderIcons := BorderIcons + [biMinimize];
    BorderStyle := bsSingle;
  end;
  if pbooFromService then begin
    mniClose.Visible := False;
    mniN1.Visible := False;
  end;
  AddIcon;
end;

procedure TFrmService.mniCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmService.mniPropertiesClick(Sender: TObject);
begin
  ShowModal;
end;

procedure TFrmService.UIClose(var Message: TMessage);
begin
  close;
end;

procedure TFrmService.UIInitialize(var Message: TMessage);
begin
  Initialize(Message.WParam <> 0);
end;

procedure TFrmService.WMSVCIcon(var Message: TMessage);
var
  vpntpt: TPoint;
begin
  case Message.LParam of
    WM_RBUTTONUP: begin
      if not Visible then begin
        SetForegroundWindow(Handle);
        GetCursorPos(vpntpt);
        mnuPopup.Popup(vpntpt.x, vpntpt.y);
      end else
        SetForegroundWindow(Handle);
    end;
    WM_LBUTTONDBLCLK: begin
      if Visible then
        SetForegroundWindow(Handle) else
        mniPropertiesClick(nil);
    end;
  end;
end;

end.
