unit bugService;

interface

uses
  SvcMgr, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ShellAPI, ExtCtrls, StdCtrls, ComCtrls,  Registry;

type
  TAFService = class(TService)
  private
    FMessageHandle: THandle;
    procedure SetMessageHandle(const Value: THandle);
  protected
    procedure Start(Sender: TService; var Started: Boolean);
    procedure Stop(Sender: TService; var Stopped: Boolean);
  public
    function GetServiceController: TServiceController; override;
    constructor CreateNew(AOwner: TComponent; Dummy: Integer = 0); override;
    constructor CreateNewCustom(AOwner: TComponent; ApplicationName: String;
                ServiceName: String; Dummy: Integer = 0);
    property MessageHandle: THandle read FMessageHandle write SetMessageHandle;
  end;

implementation

uses
  bugServiceApplication, bugSvcCnst;

{ TAFService }

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  svcService.Controller(CtrlCode);
end;

function TAFService.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

constructor TAFService.CreateNew(AOwner: TComponent; Dummy: Integer);
begin
  inherited CreateNew(AOwner, Dummy);
  AllowPause := False;
  Interactive := True;
  OnStart := Start;
  OnStop := Stop;
end;

procedure TAFService.Start(Sender: TService; var Started: Boolean);
begin
  PostMessage(FMessageHandle, UI_INITIALIZE, 1, 0);
  Started := True;
end;

procedure TAFService.Stop(Sender: TService; var Stopped: Boolean);
begin
  PostMessage(FMessageHandle, UI_CLOSE, 0, 0);
  Stopped := True;
end;


constructor TAFService.CreateNewCustom(AOwner: TComponent;
  ApplicationName, ServiceName: String;  Dummy: Integer);
begin
  CreateNew(AOwner, Dummy);
  DisplayName := ApplicationName;
  Name := ServiceName;
end;

procedure TAFService.SetMessageHandle(const Value: THandle);
begin
  FMessageHandle := Value;
end;


end.
